//+------------------------------------------------------------------+
//|                                     Current: OrderHistory V2.mq4 |
//|        Copyright  2007, Pips4life @ http://www.ForexFactory.com |
//|                                    Previous: OrderHistory.mq4    |
//|        Copyright  2005, Arunas Pranckevicius(T-1000), Lithuania |
//|                                      irc://irc.omnitel.net/forex |
//|   Modification History:                                          |
//|   V2 2007-Sep-12    by Pips4life @ http://www.ForexFactory.com   |
//+------------------------------------------------------------------+
//
// Original (V1) came from: http://codebase.mql4.com/318
// V2 rewrite is posted at: http://forexfactory.com/showthread.php?t=46668
//

#property copyright "Copyright  2005, Arunas Pranckevicius(T-1000), Lithuania"
#property copyright "V2 Copyright  2007, Pips4life @ http://www.forexfactory.com"
#property link      "irc://irc.omnitel.net/forex"

//Here are common things the user may wish to customize and then re-compile:

extern bool DisplayLines  = 1;			// Visually show fixed-length trendlines for all orders
extern int  DisplayArrows = 1;			// 0 = Turns off the display of all arrows.
						// 1 = Displays arrows for Buy/Sell/SL/TP
						// 2 = Displays only limited Buy/Sell arrows which is

extern bool DisplayTexts  = 0;			// Although decent, these texts may get a little too crowded to read.
extern double ExpandTextFactor = 1.0;		// Closer together, use < 1.0.  Farther apart, use > 1.0.

extern bool SubtractFixedSpreadForBuys = 0;	// Subtract spread from the Buy portion of all trades.
						// Affects placement of graphical Lines and Arrows only.
						// Note: Using fixed spreads may not be appropriate for your broker,
						// especially the spread at the moment you execute this script.
                                            
extern bool ConsiderTotalNetProfit = 0;		// Include Swap and Commission charges to decide if a trade was profitable

// List of colors used below (search for and change them as desired):
// Aqua, Blue, Gray, Gold, HotPink, Orchid, PaleTurquoise, Red, White, Yellow


/* Instructions for use:
1. Copy this script to the location:
C:\Program Files\<your MT4 name here>\experts\scripts

2. Exit & restart MT4 (This is usually the surest way although there may be an alternative).
3. Open a new blank chart that you have done historical trades on. 
4. From the Navigator window, expand "Scripts"
5. Drag-and-drop this script onto the chart.
6. Change the chart timeframe as desired to see detailed points of entry. The M1 or M5 
     charts are usually more informative and easier to read.

7. Optional:  Open MetaEditor and edit the script's defaults or colors then compile it,
then re-drag-and-drop the script onto the chart.
  
Examples:
A. Turn on/off the DisplayTexts option further below.
B. Turn off both lines and text.  Use the DisplayArrows=2 (a.k.a. LimitArrows) option.
You will see only your entries without knowing what happened.  You can then
step through bar-by-bar (use F12) to watch the price action, and guess 
whether those were good or bad entries and where you think you should have
exited or how you should have set S/L and T/P.  Then highlight the arrow to 
know how it actually played out, which will display Pips/SL/TP/profit.

If you make changes, unlike an indicator, I don't 
know how to change external script variables other than to 
just edit the script, recompile, and re-drag-and-drop.


*/
//
//
/* 2007-Sep-12 V2 Enhancements (Pips4life):

* Most sections rewritten.  However, as I am a hacker, not a programmer, the 
code may not be the best or most elegant.  Seems to work pretty well though.

* Added lines to graphically show the duration of the trade, at 
entry and exit.  The color and line style indicate whether it was a Buy or 
Sell, and whether it was positive or negative profit.

* V1 had bugs with confusing OrderProfit and OrderTakeProfit.  Placement of 
some arrows made no sense before.  Text placement was more crowded. Fixed.

* Cancelled orders are distinguished from opened/closed orders.

* Swap and Commission are now considered when deciding if a trade has a net profit.
(Note: I don't pay Commissions with my broker, only the usual Spread.  My assumption 
is Commission entries are negative numbers (charges).  If they
are positive numbers in the database, the calculation must be changed.)


Future Enhancement Ideas / Bug Fixes:
(Anyone willing to implement any of these ideas may do so.  Post the updates
back on the forexfactory.com forum.  Call it V2_1, for example).

* Open another window to track running relative profit/loss (a running subtotal).
In the same window, or perhaps another window, there could be a bar for absolute
profit/loss for any trade closed right above it.  Perhaps a histogram and/or a line.

* Statistics could be displayed on the chart.  Biggest loss/gain, consecutive
losses/gains, drawdown, peak profit, etc.

* Flag the peak profit that had been obtained between open and close.  Especially
helpful if you ended up taking a loss instead of once-obtained-profit.

* Consider hypothetical adjustment of stop-loss, making it larger.  Find the peak
high (for buy) or low (for sell) that occurred after that without hitting the S/L.
Similarly, ignore the T/P and make the same calculation.

Peak after T/P can already be determined for orders that hit T/P with the current S/L.

* Add a start date and end date option.  Calculate orders between (or just after) 
the specified date(s).  Need to decide whether the option should apply to orders 
opened within the dates, and/or orders closed within the dates that had openings
prior to the start date.  

* Consider how currently open orders are handled.  I don't think they get displayed
at all until they are closed.  Probably just display the Arrows and Texts but not
Lines.  Change the Description to indicate the order is open, so Net$ = Unknown.

* Consider making this an indicator rather than a script if there are advantages.
As I'm not an expert at scripts, I'm unaware how to change defaults except to just
edit the script, re-compile, and then re-drag-and-drop.  That seems like a hassle 
compared to an indicator where the external variables can be more easily changed. 

* Personally, I'm not totally satisfied with the placement of texts although it is
improved.  Consider using the current timeframe's iATR instead of 60 minutes only.
Consider detecting whether the newest text object is on top of previous text. 
(Compare Price and possibly time).  If texts could be Left Justified, that would
be helpful.  The current Center Justification makes it harder to line up which
text goes with which arrow. (Or even Right Justification could be better??).

* Need a way to help identify multiple orders with the same entry price/time/exit,
especially S/L exits.  The actual loss would be X times larger.  The current
charts may well show the quality of entries and exits but not well the quantity
(lot sizes and if there were multiple positions).  Maybe a histogram of profit
can stack each profit or loss so one can see there were multiple orders instead
of just one.  At present, there will be multiple offset texts, but the arrows 
and lines will be on top of each other.


*/
//


// Other than colors and/or arrow choices or line styles, the typical user of this 
// script should not need to customize anything below this line
// ============================================================================

#include <stdlib.mqh>

void SetArrow(string ArrowName, string ArrowDescription, datetime ArrowTime, double Price, double ArrowCode, color ArrowColor, bool LimitArrow)
{
   int err;

   // Note, if ArrowName was already used, the object will be replaced by current arrow.
   if (ObjectFind(ArrowName) != -1) ObjectDelete(ArrowName);
   if (!DisplayArrows || (DisplayArrows == 2 && LimitArrow))  return; // Return after deleting existing arrow is deliberate.
   if(!ObjectCreate(ArrowName, OBJ_ARROW, 0, ArrowTime, Price))
    {
     err=GetLastError();
     Print("error: can't create Arrow! code #",err," ",ErrorDescription(err));
     return;
    }
   else
   { 
   ObjectSet(ArrowName, OBJPROP_ARROWCODE, ArrowCode);
   ObjectSet(ArrowName, OBJPROP_COLOR , ArrowColor);
   ObjectSet(ArrowName, OBJPROP_WIDTH  , 1);
   
   ObjectSetText(ArrowName, ArrowDescription, 8, "Arial", ArrowColor);
   ObjectsRedraw();
   }
}



void SetText(string TextName, string TextDescription, datetime TextTime, double TextPrice, color TextColor)
{
   int err;
   
   if (ObjectFind(TextName) != -1) ObjectDelete(TextName);
   if (!DisplayTexts)  return; // Return after deleting existing text is deliberate.
   if (!ObjectCreate(TextName, OBJ_TEXT, 0, TextTime, TextPrice))
   {
     err=GetLastError();
     Print("error: can't create Text! code #",err," ",ErrorDescription(err));
     return(0);
   }
   else
   {
   ObjectSetText(TextName,TextDescription,10,"Times New Roman", TextColor);
   ObjectsRedraw();
   }
}          

void SetLine(string ObjName, string LineDescription, datetime LineOpenTime, double LineOpenPrice, datetime LineCloseTime, 
double LineClosePrice, color LineColor, int LineWidth, int LineStyle)
{             
   int err;
   
   if (ObjectFind(ObjName) != -1) ObjectDelete(ObjName);
   if (!DisplayLines)  return; // Return after deleting existing line is deliberate.
   if(!ObjectCreate(ObjName, OBJ_TREND, 0, LineOpenTime, LineOpenPrice, LineCloseTime, LineClosePrice))
   {
     err=GetLastError();
     Print("error: can't create Line! code #",err," ",ErrorDescription(err));
     return(0);
   }
   else
   {
   ObjectSet(ObjName,OBJPROP_RAY,0);
   ObjectSet(ObjName,OBJPROP_COLOR,LineColor);
   ObjectSet(ObjName,OBJPROP_WIDTH,LineWidth); 
   ObjectSet(ObjName,OBJPROP_STYLE,LineStyle);   
   ObjectSetText(ObjName, LineDescription, 10, "Times New Roman", LineColor);
   ObjectsRedraw();
   }
}   
              
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
//---- 
// retrieving info from trade history
  int    i,hstTotal=HistoryTotal();
  int    HistoryOrderType; 
  string HistoryOrderTypeString;
  int    HistoryOrderTicket; 
  int    HistoryOrderCloseTime;
  double HistoryOrderClosePrice;
  int    HistoryOrderOpenTime;
  double HistoryOrderOpenPrice;
  double HistoryOrderProfit;
  double HistoryOrderSwap;
  double HistoryOrderCommission;
  double HistoryOrderTakeProfit;
  double HistoryOrderStopLoss;
  double HistoryOrderLots;
  double PlaceTextAtPrice;
  //string HistoryOrderComment; // Not necessary for now.
  string OrderName;
  string OrderDescription;
  string TextDescription;
  string ObjName;
  string ProfitString;
  double Spread = 0;
  double NetProfit = 0;
  double NetOrGrossProfit = 0;
  
  // Decide a suitable offset for text and a delta between multiple texts for readability.
  int TextOffsetBase = MathRound(ExpandTextFactor * iATR(NULL,60,20,0)/Point + 3);
  int TextOffsetDelta = MathRound(ExpandTextFactor * 0.20 * TextOffsetBase + 3);
  int TextOffsetCounter = 0;
  Print(" 60/20 iATR is: ",iATR(NULL,60,20,0)," TextOffsetBase: ",TextOffsetBase,"  TextOffsetDelta: ",TextOffsetDelta);
  
  int SLpips;
  int TPpips;
  int NETpips;
  
  int SigDigits = 5;
  if (Point > 0.0001) SigDigits = 2; // AFAIK, valid Point values are 0.01 or 0.0001
 
  if (SubtractFixedSpreadForBuys) 
  {
     RefreshRates( ); 
     Spread = Ask - Bid;
     // Note: This is valid for fixed-spread brokers, but not necessarily accurate
     // for brokers who change the spread a lot.  A non-typical spread at the moment this 
     // script is executed would be especially misleading.  However, it will only
     // affect where objects are drawn.  The reported price/TP/SL/etc numbers are
     // unaffected.
  }

  for(i=0;i<hstTotal;i++)
  {
     //---- check selection result
     if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
     {
        Print("Access to history failed with error (",GetLastError(),")");
        break;
     }
     HistoryOrderType = OrderType();
     if (OrderSymbol() == Symbol())
     { // The order was for the same currency pair as this chart...
     
        HistoryOrderCloseTime=OrderCloseTime();
        HistoryOrderClosePrice=OrderClosePrice();
        HistoryOrderOpenTime=OrderOpenTime();
        HistoryOrderOpenPrice=OrderOpenPrice();
        HistoryOrderProfit=OrderProfit();
        HistoryOrderSwap=OrderSwap();
        HistoryOrderCommission=OrderCommission();
        HistoryOrderTakeProfit=OrderTakeProfit();
        HistoryOrderStopLoss=OrderStopLoss();
        HistoryOrderTicket=OrderTicket();
        HistoryOrderLots=OrderLots();
        //HistoryOrderComment=OrderComment();
        
                
        // NOTE: My assumption is that Commission entries are negative, hence they are added.
        // If instead they are positive numbers (charged) then it should be subtracted below, not added.
        // Following does not consider Taxes withheld (because I don't know the function to retrieve it).
        // However, one probably wouldn't want to consider Taxes in the calculation anyway.
        NetProfit = HistoryOrderProfit+HistoryOrderSwap+HistoryOrderCommission;
        if (ConsiderTotalNetProfit)
        {
          NetOrGrossProfit = NetProfit; // Net profit
          ProfitString = "Net: $ "+DoubleToStr(NetProfit,2);
        }
        else
        {
          NetOrGrossProfit = HistoryOrderProfit; // Gross profit
          ProfitString = "Gross: $ "+DoubleToStr(HistoryOrderProfit,2);
        }
        
        // Calculate in terms of pips: Profit, S/L and T/P
        NETpips = 0;
        SLpips = 0;
        TPpips = 0;
        if (HistoryOrderType == OP_BUY || HistoryOrderType == OP_BUYSTOP || HistoryOrderType == OP_BUYLIMIT)
        { // This was a Buy order 
           if (HistoryOrderProfit != 0)    NETpips=MathRound((HistoryOrderClosePrice-HistoryOrderOpenPrice)/Point);
           if (HistoryOrderStopLoss > 0)   SLpips=MathRound((HistoryOrderStopLoss-HistoryOrderOpenPrice)/Point);
           if (HistoryOrderTakeProfit > 0) TPpips=MathRound((HistoryOrderTakeProfit-HistoryOrderOpenPrice)/Point);
        }
        else
        { // This was a Sell order
           if (HistoryOrderProfit != 0)    NETpips=MathRound((HistoryOrderOpenPrice-HistoryOrderClosePrice)/Point);
           if (HistoryOrderStopLoss > 0)   SLpips=MathRound((HistoryOrderOpenPrice-HistoryOrderStopLoss)/Point);
           if (HistoryOrderTakeProfit > 0) TPpips=MathRound((HistoryOrderOpenPrice-HistoryOrderTakeProfit)/Point);        
        }
 
        
        // Create shortcut text names to use in object descriptions    
        switch(HistoryOrderType)
        {
         case OP_BUY:
            HistoryOrderTypeString = "Buy";
            break;
         case OP_BUYSTOP:
            HistoryOrderTypeString = "BySt";
            break;
         case OP_BUYLIMIT:
            HistoryOrderTypeString = "BLmt";
            break;
         case OP_SELL:
            HistoryOrderTypeString = "Sell";
            break;
         case OP_SELLSTOP:
            HistoryOrderTypeString = "SlSt";
            break;
         case OP_SELLLIMIT:
            HistoryOrderTypeString = "SLmt";
            break;
         default:
           Print("error: unknown OrderType: ",HistoryOrderType);
           return;
        }
        
        OrderName = DoubleToStr(HistoryOrderTicket,0)+" "+TimeToStr(HistoryOrderOpenTime)+" @ "+DoubleToStr(HistoryOrderOpenPrice,SigDigits);
        OrderDescription = "Pips: "+NETpips+"  SL: "+SLpips+"  TP: "+TPpips+"  Lots: "+DoubleToStr(HistoryOrderLots,2)+"  "+ProfitString;
        Print("Order ",OrderName," : ",OrderDescription);
        
        
        
        ////////////// Begin section to display texts
        // First figure out at what price to place the text.
        if (HistoryOrderType == OP_BUY || HistoryOrderType == OP_BUYSTOP || HistoryOrderType == OP_BUYLIMIT)
        { // Place Buy text a calculated pips below open price
           PlaceTextAtPrice = (HistoryOrderOpenPrice-TextOffsetBase*Point-TextOffsetDelta*TextOffsetCounter*Point);
        }
        else
        { // Place Sell text a calculated pips above open price
           PlaceTextAtPrice = (HistoryOrderOpenPrice+TextOffsetBase*Point+TextOffsetDelta*TextOffsetCounter*Point);
        }
        TextOffsetCounter++;
        if (TextOffsetCounter >= 4) TextOffsetCounter = 0; // Larger number handles more orders at same price/time but offsets grow larger.
          
        ObjName = HistoryOrderTypeString+"_"+OrderName;
        TextDescription = HistoryOrderTypeString+"_"+DoubleToStr(HistoryOrderTicket,0)+" @ "+DoubleToStr(HistoryOrderOpenPrice,SigDigits)+
            "  Pips: "+NETpips+"  "+ProfitString;
         
        SetText(ObjName, TextDescription, HistoryOrderOpenTime, PlaceTextAtPrice, Yellow);
          
        // Possibly adjust text placement above based on the previous text stored here for the next text.
        //LastPlaceTextAtPrice = PlaceTextAtPrice; 
          
        /////////////////// end of text section



        ////////////////// The next DisplayLines section is the most signficant enhancement added to V2:
        
        if (HistoryOrderType == OP_BUY || HistoryOrderType == OP_BUYSTOP || HistoryOrderType == OP_BUYLIMIT)
        { // A Buy Order, either cancelled or positive-profit or negative-profit.
           
          // Is this a cancelled order?
          // Possible alternate for cancelled orders:  if (StringFind(HistoryOrderComment,"cancelled",0) >= 0)
          if (HistoryOrderProfit == 0 && HistoryOrderOpenPrice != HistoryOrderClosePrice)
          { // Draw a Cancelled-Buy trendline
            ObjName = "C_"+HistoryOrderTypeString+" "+OrderName;
            SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice-Spread, HistoryOrderCloseTime, 
                HistoryOrderOpenPrice-Spread, Gray, 1, STYLE_DOT);
          } // end of if it was cancelled
          else 
          { // buy order was not cancelled
              
            // Was this profitable or break-even?
            if (NetOrGrossProfit >= 0)
            {
              // Draw a Positive (profitable or break-even) Buy trendline
              ObjName = "P_"+HistoryOrderTypeString+" "+OrderName;
              SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice-Spread, HistoryOrderCloseTime, 
                  HistoryOrderClosePrice, Green, 1, STYLE_DOT);
            } 
            else 
            {
              // Draw a Negative (loosing) Buy trendline
              ObjName = "N_"+HistoryOrderTypeString+" "+OrderName;
              SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice-Spread, HistoryOrderCloseTime, 
                  HistoryOrderClosePrice, Red, 1, STYLE_DOT);              
            } 
          } // end -- a buy was cancelled or not
        } // end all buys
        else 
        {
          // A sell order, either cancelled or positive-profit or negative-profit.
            
          // Is this a cancelled order?
          // Possible alternate for cancelled orders:  if (StringFind(HistoryOrderComment,"cancelled",0) >= 0)
          if (HistoryOrderProfit == 0 && HistoryOrderOpenPrice != HistoryOrderClosePrice)
          {
            // Draw a Cancelled Sell trendline
            ObjName = "C_"+HistoryOrderTypeString+" "+OrderName;
            SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice, HistoryOrderCloseTime, 
                HistoryOrderOpenPrice, Gray, 1, STYLE_DOT);
          } // end of if it was cancelled
          else 
          { // order was not cancelled
            // A Sell order
              
            // Was this profitable or break-even?
            if (NetOrGrossProfit >= 0)
            { 
              // Draw a Profitable or Break Even Sell trendline
              ObjName = "P_"+HistoryOrderTypeString+" "+OrderName;
              SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice, HistoryOrderCloseTime, 
                  HistoryOrderClosePrice-Spread, Green, 1, STYLE_DOT);  
            } 
            else 
            {
              // Draw a Loosing Sell trendline
              ObjName = "N_"+HistoryOrderTypeString+" "+OrderName;
              SetLine(ObjName, OrderDescription, HistoryOrderOpenTime, HistoryOrderOpenPrice, HistoryOrderCloseTime, 
                  HistoryOrderClosePrice-Spread, Red, 1, STYLE_DOT);      
            }               
          } // end non-cancelled sells
        } // end all sells
        ////////////////// end of DisplayLines section 
      
      
      
        ////////////////// Begin DisplayArrows section
        
        if (HistoryOrderType == OP_BUY || HistoryOrderType == OP_BUYSTOP || HistoryOrderType == OP_BUYLIMIT)
        {
          // A Buy Order, either cancelled or break-even or positive-profit or negative-profit.
          // Not, however, currently Open orders (I think).
            
          // For all Buy orders, put down these arrow(s)
            
          // OLD V1: LAST arrow at same time/price will overwrite previous arrows!  Consider the order carefully!
          if (HistoryOrderTakeProfit > 0) SetArrow("Buy TP: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderTakeProfit,4,Green, TRUE);				// Target arrow for T/P if non-0
          if (HistoryOrderStopLoss > 0) SetArrow("Buy SL: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderStopLoss,4,Red, TRUE);				// An "x" arrow for S/L if non-0
          if (HistoryOrderType == OP_BUY) SetArrow("Buy: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice-Spread,1,Gray, NULL);			// Buy arrow
          if (HistoryOrderType == OP_BUYLIMIT) SetArrow("Buy Limit: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice-Spread,228,Gray, NULL);		// BuyLimit 45 slanted arrow
          if (HistoryOrderType == OP_BUYSTOP) SetArrow("Buy Stop: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice-Spread,200,Gray, NULL);		// BuyStop 90 degree bend-up arrow
            
          // Is this a cancelled order?
          // Possible alternate for cancelled orders:  if (StringFind(HistoryOrderComment,"cancelled",0) >= 0)
          if (HistoryOrderProfit == 0 && HistoryOrderOpenPrice != HistoryOrderClosePrice)
          {
            // If cancelled, we do no further arrows.  
            // FYI, using the same "if" logic as before makes it easier to maintain the code.
          }
          else 
          { // order was not cancelled
            if (NetOrGrossProfit == 0 )
            { // close at B.E. (break even)
              SetArrow("BE Close (B)"+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,162,Aqua, TRUE);			// A zero for B.E. close.
            }
            else if (NetOrGrossProfit > 0 )
            { // order was profitable
              if (HistoryOrderTakeProfit != 0 && HistoryOrderClosePrice >= HistoryOrderTakeProfit)
              { // close at profit at T/P
                SetArrow("TP Close [P] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Green, FALSE);		// A smiley face for T.P. close.
              }
              else if (HistoryOrderStopLoss != 0 && HistoryOrderClosePrice <= HistoryOrderStopLoss)
              { // close at profit at S/L 
                SetArrow("SL Close [P] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Green, TRUE);			// A checkmark-in=-a-box for profitable S/L close.
              }
              else 
              { // manually close at profit
                SetArrow("Manually Closed [P] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Green, TRUE);		// A checkmark for profitable manual close.
              }
            }
            else
            { // Profit is negative (a loss).
              if (HistoryOrderStopLoss != 0 && HistoryOrderClosePrice <= HistoryOrderStopLoss)
              { // close at loss at S/L 
                SetArrow("SL Close [L] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Red, TRUE);			// A skull-and-bones(78), or bomb(77), for negative S/L close.
              }
              else if (HistoryOrderTakeProfit != 0 && HistoryOrderClosePrice >= HistoryOrderTakeProfit)
              { // close at loss at a reduced T/P
                SetArrow("TP Close [L] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Red, TRUE);			// A x-in-a-box for negative T.P. close.
              }
              else
              { // manually close at a loss
                SetArrow("Manually Closed [L] (B): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice,3,Red, TRUE);		// A scissors (to cut losses) for a negative manual close
              }              
            } // end profit is negative
          } // end order was not cancelled.
        } // end order is a buy order
        else
        { // Trade is a Sell order, either cancelled or break-even or positive-profit or negative-profit.
            
          // For all Sell orders, put down these arrow(s)
            
          // LAST arrow at same time/price will overwrite previous arrows!  Consider the order carefully!
          if (HistoryOrderTakeProfit > 0) SetArrow("Sell TP: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderTakeProfit,4,Green, TRUE);			// Target arrow for T/P if non-0
          if (HistoryOrderStopLoss > 0) SetArrow("Sell SL: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderStopLoss,4,Red, TRUE);			// An "x" arrow for S/L if non-0
          if (HistoryOrderType == OP_SELL) SetArrow("Sell: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice,1,Gray, NULL);			// Sell arrow
          if (HistoryOrderType == OP_SELLLIMIT) SetArrow("Sell Limit: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice,230,Gray, NULL);	// BuyLimit 45 slanted arrow
          if (HistoryOrderType == OP_SELLSTOP) SetArrow("Sell Stop: "+OrderName, OrderDescription, HistoryOrderOpenTime,HistoryOrderOpenPrice,202,Gray, NULL);		// BuyStop 90 degree bend-up arrow
            
          // Is this a cancelled order?
          // Possible alternate for cancelled orders:  if (StringFind(HistoryOrderComment,"cancelled",0) >= 0)
          if (HistoryOrderProfit == 0 && HistoryOrderOpenPrice != HistoryOrderClosePrice)
          {
            // If cancelled, we do no further arrows.  
            // FYI, using the same "if" logic as before makes it easier to maintain the code.
          }
          else 
          { // order was not cancelled
            if (NetOrGrossProfit == 0 )
            { // close at B.E. (break even)
              SetArrow("BE Close (S)"+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,162,Aqua, TRUE);				// A zero for B.E. close.
            }
            else if (NetOrGrossProfit > 0 )
            { // order was profitable
              if (HistoryOrderTakeProfit != 0 && HistoryOrderClosePrice <= HistoryOrderTakeProfit)
              { // close at profit at T/P
                SetArrow("TP Close [P] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Green, TRUE);			// A smiley face for T.P. close.
              }
              else if (HistoryOrderStopLoss != 0 && HistoryOrderClosePrice >= HistoryOrderStopLoss)
              { // close at profit at S/L 
                SetArrow("SL Close [P] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Green, TRUE);			// A checkmark-in=-a-box for profitable S/L close.
              }
              else 
              { // manually close at profit
                SetArrow("Maually Closed [P] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Green, TRUE);		// A checkmark for profitable manual close.
              }
            }
            else
            { // Profit is negative.
              if (HistoryOrderStopLoss != 0 && HistoryOrderClosePrice >= HistoryOrderStopLoss)
              { // close at loss at S/L 
                SetArrow("SL Close [L] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Red, TRUE);			// A skull-and-bones(78), or bomb(77), for negative S/L close.
              }
              else if (HistoryOrderTakeProfit != 0 && HistoryOrderClosePrice-Spread <= HistoryOrderTakeProfit)
              { // close at loss at a reduced T/P
                SetArrow("TP Close [L] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Red, TRUE);			// A x-in-a-box for negative T.P. close.
              }
              else
              { // manually close at a loss
                SetArrow("Manually Closed [L] (S): "+OrderName, OrderDescription, HistoryOrderCloseTime,HistoryOrderClosePrice-Spread,3,Red, TRUE);		// A scissors (to cut losses) for a negative manual close
              }              
            } // end profit is negative
          } // end order was not cancelled.
        } // end of sell Orders.    
        // end of DisplayArrows section
          
          
     } // end OrderSymbol
  } // end for hstTotal loop to process all orders
   
//----
   return(0);
} // end start
//+------------------------------------------------------------------+